Committer: Michael Beasley <mike@snafu.setup>
[mikesnafu-overlay.git] / scripts / kconfig / lxdialog / check-lxdialog.sh
blob62e1e02126e61d5cde4945c9d7f922153ea6f90e
1 #!/bin/sh
2 # Check ncurses compatibility
4 # What library to link
5 ldflags()
7 for ext in so a dylib ; do
8 for lib in ncursesw ncurses curses ; do
9 $cc -print-file-name=lib${lib}.${ext} | grep -q /
10 if [ $? -eq 0 ]; then
11 echo "-l${lib}"
12 exit
14 done
15 done
16 exit 1
19 # Where is ncurses.h?
20 ccflags()
22 if [ -f /usr/include/ncurses/ncurses.h ]; then
23 echo '-I/usr/include/ncurses -DCURSES_LOC="<ncurses.h>"'
24 elif [ -f /usr/include/ncurses/curses.h ]; then
25 echo '-I/usr/include/ncurses -DCURSES_LOC="<ncurses/curses.h>"'
26 elif [ -f /usr/include/ncurses.h ]; then
27 echo '-DCURSES_LOC="<ncurses.h>"'
28 else
29 echo '-DCURSES_LOC="<curses.h>"'
33 # Temp file, try to clean up after us
34 tmp=.lxdialog.tmp
35 trap "rm -f $tmp" 0 1 2 3 15
37 # Check if we can link to ncurses
38 check() {
39 echo -e " #include CURSES_LOC \n main() {}" |
40 $cc -xc - -o $tmp 2> /dev/null
41 if [ $? != 0 ]; then
42 echo " *** Unable to find the ncurses libraries or the" 1>&2
43 echo " *** required header files." 1>&2
44 echo " *** 'make menuconfig' requires the ncurses libraries." 1>&2
45 echo " *** " 1>&2
46 echo " *** Install ncurses (ncurses-devel) and try again." 1>&2
47 echo " *** " 1>&2
48 exit 1
52 usage() {
53 printf "Usage: $0 [-check compiler options|-header|-library]\n"
56 if [ $# -eq 0 ]; then
57 usage
58 exit 1
61 cc=""
62 case "$1" in
63 "-check")
64 shift
65 cc="$@"
66 check
68 "-ccflags")
69 ccflags
71 "-ldflags")
72 shift
73 cc="$@"
74 ldflags
76 "*")
77 usage
78 exit 1
80 esac